/*
 * Polynomial.cpp
 *
 *  Created on: Nov 24, 2022
 *      Author: thanh
 */

#include "Polynomial.h"

Polynomial::Polynomial()
{
    degree_ = 0;
    for (size_t i = 0; i < MAX_DEGREE; i++)
    {
        coeffs_[i] = 0;
    }
}

ostream& operator<<(ostream &os, const Polynomial &p)
{
    bool isFirst = true;
    for (size_t i = 0; i < MAX_DEGREE; i++)
    {
        if (p.coeffs_[i] != 0.0)
        {
            if (i > 0)
            {
                if (p.coeffs_[i] > 0)
                {
                    if (!isFirst)
                        os << " + ";
                    os << p.coeffs_[i];
                }
                else if (p.coeffs_[i] < 0)
                {
                    if (!isFirst)
                        os << " - ";
                    os << (p.coeffs_[i] * (-1));
                }
                os << "*x^" << i;
            }
            else
            {
                os << p.coeffs_[i];
            }
            isFirst = false;
        }
    }
    return os;
}

istream& operator>>(istream &input, Polynomial &p)
{
    input >> p.degree_;
    for (int i = 0; i <= p.degree_; i++)
    {
        input >> p.coeffs_[i];
    }
    return input;
}

Polynomial Polynomial::operator +(Polynomial const &obj)
{
    Polynomial sum;
    for (size_t i = 0; i < MAX_DEGREE; i++)
    {
        sum.coeffs_[i] = coeffs_[i] + obj.coeffs_[i];
        if(sum.coeffs_[i] != 0) {
            sum.degree_ = i;
        }
    }
    return sum;
}

Polynomial Polynomial::operator -(Polynomial const &obj)
{
    Polynomial sub;
    for (size_t i = 0; i < MAX_DEGREE; i++)
    {
        sub.coeffs_[i] = coeffs_[i] - obj.coeffs_[i];
    }
    return sub;
}

// j o h n n y t u o t - g m a i l - c o m
double Polynomial::eval(double x) {
    double result = 0;
    for (int i = 0; i <= degree_; i++)
    {
        double val = 1;
        for(int j = 0; j < i; j++) {
            val *= x;
        }
        result += (coeffs_[i] * val);
    }
    return result;
}
